/* Jalview - a java multiple alignment editor
 * Copyright (C) 1998  Michele Clamp
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

package jalview.schemes;


import java.util.*;
import java.awt.*;

public class Blosum62ColourScheme extends ResidueColourScheme
{

  public Blosum62ColourScheme()
  {
    super();
  }

  public Color findColour(String s, int j)
  {
    if( threshold!=0 && !aboveThreshold(s,j))
      return Color.white;

    Hashtable hash = (Hashtable)consensus.elementAt(j);

    if (!jalview.util.Comparison.isGap((s.charAt(0))))
    {
      String    max  = (String)hash.get("maxResidue");

      if (max.indexOf(s)>-1)
        return new Color(154, 154, 255);
      else {

        int c = 0,
            max_aa=0,
            n=max.length();
        do {
          c+=ResidueProperties.getBLOSUM62(max.substring(max_aa, max_aa+1), s);
        } while (++max_aa<n);

        if (c>0)
          return new Color(204, 204, 255);
        else
          return Color.white;
      }
    }
    else
        return Color.white;

  }


}
